
#ifndef WIN32PORT_PWD_H
#define WIN32PORT_PWD_H

#ifdef __cplusplus
	extern "C" {
#endif

#define MAX_PW_NAME_LEN 64


/* Simulate the UNIX passwd structure to ease things a bit... */
struct passwd {
	char	*pw_name;       /* user name */
/*	char    *pw_passwd;     encrypted password */
	uid_t   pw_uid;         /* user uid */
/*	gid_t   pw_gid;         user gid */
/*	time_t  pw_change;      password change time */
/*	char    *pw_class;      user access class */
/*	char    *pw_gecos;      Honeywell login info */
	char    *pw_dir;        /* home directory */
	char    *pw_shell;      /* default shell */
/*	time_t  pw_expire;      account expiration */
	char pw_name_buf[MAX_PW_NAME_LEN];
	char pw_dir_buf[MAX_PATH];
	char pw_shell_buf[MAX_PATH];
};

#define getpwuid win32port_getpwuid
#define getpwnam win32port_getpwnam

struct passwd *win32port_getpwuid(uid_t uid);
struct passwd *win32port_getpwnam(const char *login);

#ifdef __cplusplus
	}
#endif


#endif /* WIN32PORT_PWD_H */