
#include "includes.h"
#include "ssh.h"

int daemon(int nochdir, int noclose) {
	char buf[MAX_PATH], *p;
	DWORD (PASCAL *__RegisterServiceProcess)(DWORD dwProcessId, DWORD dwType);
	HINSTANCE hLibrary = LoadLibrary("KERNEL32.DLL");

	if (nochdir == 0) {
		strcpy(buf, "C:\\");
		if (GetWindowsDirectory(buf, sizeof(buf))) {
			p = buf;
			if (('\\' == p[0]) && ('\\' == p[1]) && isascii(p[2])) {
				/* UNC path */
				p += 2;
				while(*p && ('\\' != *p))
					++p;
				if (*p == '\\')
					++p;
				while(*p && ('\\' != *p))
					++p;
				if ('\\' == *p)
					*p = 0;
			}
			else if (isascii(p[0]) && (':' == p[1]) && ('\\' == p[2])) {
				/* 'classic' path */
				p[3] = 0;
			}
		}
		SetCurrentDirectory(buf);
	}

	FreeConsole();
	
	if (hLibrary) {	
		__RegisterServiceProcess = 
			(DWORD (PASCAL *)(DWORD, DWORD))GetProcAddress(hLibrary, 
			"RegisterServiceProcess");
		if ((__RegisterServiceProcess == NULL)
			|| (__RegisterServiceProcess(0, 1) != 1)) {
			AllocConsole();
			error("ERROR: Failed to register as system-level service (daemon)");
			FreeLibrary(hLibrary);
			return -1;
		}

		FreeLibrary(hLibrary);
	}
	else 
	{
		AllocConsole();
		error("ERROR: Cound not load KERNEL32.DLL and set daemon mode");
		return -1;
	}

	return 0;
}

