
#include "includes.h"

const char *win32port_get_canonical_name(void) {
	char *p;
	__declspec( thread ) static char rbuf[128];
	DWORD uname_len = sizeof(rbuf);

	if (rbuf[0])
		return rbuf;

	GetUserName(rbuf, &uname_len);

	if ((strlen(rbuf) + 1) >= sizeof(rbuf))
		return "out_of_buffer_space";

	if (strlen(rbuf) == 0)
		strcpy(rbuf, "nobody");

	for(p = rbuf; *p; p++) {
		if (isspace(*p))
			*p = '_';
		if (isupper(*p))
			*p = tolower(*p);
		if (!strchr("abcdefghijklmnopqrstuvwzyz1234567890_", *p))
			*p = 'X';
	}

	return rbuf;
}
