#include "includes.h"


#ifndef SSH_PATH_PADDING
#	define SSH_PATH_PADDING ""
#endif


/* jgaa oct 9th 2000: 
 * Get the path where ssh stores private data.
 * If the environment variable SSH_HOME is serm we use this
 * path, else we use the default private application-data path.
 * ("C:\Documents and Settings\%USER%\Application Data" by default 
 * under Windows 2000) and add /ssh at the end.
 */


const char* win32port_get_ssh_data_path(const char *filename) {
	static const char* path;
	const char *safe_filename = filename ? filename : "";
	char path_buf[_MAX_PATH], *p;
	DWORD path_buf_lenght = _MAX_PATH;
	
	path = getenv("SSH_HOME");
	if (path == NULL) {
		path_buf[0] = 0;
		if (win32port_get_registry_value(HKEY_CURRENT_USER, 
			"Software\\Microsoft\\Windows\\CurrentVersion\\Explorer\\Shell Folders",
			"AppData",
			path_buf,
			&path_buf_lenght) == 0) {
			if ((strlen(path_buf) 
				+ strlen(SSH_PATH_PADDING) 
				+ strlen(safe_filename)
				+ 2) >= _MAX_PATH) {
				return NULL;
			}
			strcat(path_buf, SSH_PATH_PADDING);
		}
	}
	else {
		if ((strlen(path_buf) 
			+ strlen(safe_filename)
			+ 2) >= _MAX_PATH) {
			return NULL;
		}
		strcpy(path_buf, path);
	}
	if (*safe_filename) {
		strcat(path_buf, "\\");
		strcat(path_buf, safe_filename);
	}
	
	for (p = path_buf; *p; *p++) {
		if (*p == '/')
			*p = '\\';
	}
	path = strdup(path_buf);
	
	return path;
}
