

#include "includes.h"
#include "ssh.h"

uid_t win32port_getuid(void) {
	__declspec(thread) static uid_t myuid;

	if (myuid != NULL)
		CloseHandle(myuid);

	myuid = NULL;
	
	if (!OpenProcessToken(GetCurrentProcess(), 
		TOKEN_IMPERSONATE | TOKEN_QUERY,
		&myuid)) {
		debug("Error: OpenProcessToken() failed in getuid()");
	}

	return myuid;
}

uid_t win32port_geteuid(void) {
	__declspec(thread) static uid_t myuid;

	if (myuid != NULL)
		CloseHandle(myuid);

	myuid = NULL;
	
	if (!OpenThreadToken(GetCurrentThread(), 
		TOKEN_IMPERSONATE | TOKEN_QUERY,
		FALSE,
		&myuid)) {
		debug("Error: OpenThreadToken() failed in geteuid()");
	}

	return myuid;
}

int win32port_setuid(uid_t uid) {
	if (!ImpersonateLoggedOnUser(uid)) {
		debug("seteuid %u: %.100s", (u_int) uid, strerror(errno));
		return -1;
	}
	return 0;
}

int win32port_seteuid(uid_t euid) {
	return win32port_setuid(euid);
}

