
/* jgaa oct 9th 2000: const char *getusername();
 * 
 * Returns a canonical name for the current user
 * Reentrant for win32
 */

#include "includes.h"

const char *win32port_getusername(int force_refresh) {
	char uname_buf[128], hname_buf[128], *p;
	DWORD uname_len = sizeof(uname_buf);
	__declspec( thread ) static char rbuf[256];

	if (!force_refresh && (0 != rbuf[0]))
		return rbuf;

	uname_buf[0] = 0;
	hname_buf[0] = 0;

	gethostname(hname_buf, sizeof(hname_buf));
	GetUserName(uname_buf, &uname_len);

	if ((strlen(hname_buf) + strlen(uname_buf) + 2) >= sizeof(rbuf))
		return "out.of@buffer.space";

	if (strlen(uname_buf) == 0)
		strcpy(uname_buf, "john.doe");

	if (strlen(hname_buf) == 0)
		strcpy(hname_buf, "unknown");

	sprintf(rbuf, "%s@%s", uname_buf, hname_buf);

	for(p = rbuf; *p; p++) {
		if (isspace(*p))
			*p = '.';
		if (isupper(*p))
			*p = tolower(*p);
		if (!strchr("abcdefghijklmnopqrstuvwzyz1234567890@.-_", *p))
			*p = 'X';
	}

	return rbuf;
}
