
#include "includes.h";
#include "ssh.h"
#include <assert.h>

int ioctl(int d, unsigned long request, ...) {
	va_list marker;

	va_start(marker, request);

	switch(request) {
	case TIOCGWINSZ:
		{
			struct winsize *pws; 
			CONSOLE_SCREEN_BUFFER_INFO ci;
			HANDLE hStdin = GetStdHandle(STD_OUTPUT_HANDLE);

			pws = va_arg(marker, struct winsize *);
			memset(&ci, 0, sizeof(ci));
			pws->ws_row = 24;
			pws->ws_col = 80;
			pws->ws_xpixel = 640;
			pws->ws_ypixel = 480;

			if ((INVALID_HANDLE_VALUE != hStdin)
				&& GetConsoleScreenBufferInfo(hStdin, &ci))
			{
				pws->ws_row = ci.dwSize.Y;
				pws->ws_col = ci.dwSize.X;
			}
		}
		break;

	default:
		error("ERROR: Unsupported ioctl call %d", request);
		assert(0);
	}

	va_end(marker);

	return 0;
}

