
/* jgaa oct 10th 2000: Check if we are running with administrator
 * privilegies 
 */

#include "includes.h"
#include <Winnt.h>

BOOL win32port_is_administrator(VOID)
{
    BOOL         fAdmin;
    HANDLE       hThread;
    TOKEN_GROUPS *ptg = NULL;
    DWORD        cbTokenGroups;
    DWORD        dwGroup;
    PSID         psidAdmin;
	
    SID_IDENTIFIER_AUTHORITY SystemSidAuthority= SECURITY_NT_AUTHORITY;
    if (!OpenThreadToken (GetCurrentThread(), TOKEN_QUERY, FALSE, &hThread)) {
        if (GetLastError() == ERROR_NO_TOKEN) {
            if (! OpenProcessToken (GetCurrentProcess(), TOKEN_QUERY, &hThread))
				return FALSE;
        }
        else 
            return FALSE;
    }
	
    if (GetTokenInformation (hThread, TokenGroups, NULL, 0, &cbTokenGroups))
        return FALSE;
	
    if (GetLastError() != ERROR_INSUFFICIENT_BUFFER)
        return (FALSE);
	
    ptg = (TOKEN_GROUPS *)malloc(sizeof(TOKEN_GROUPS) *cbTokenGroups);
	
    if (!GetTokenInformation(hThread, TokenGroups, ptg, cbTokenGroups,
		&cbTokenGroups)) {
		free(ptg);
        return FALSE;
	}
	
    if (AllocateAndInitializeSid (&SystemSidAuthority, 2, SECURITY_BUILTIN_DOMAIN_RID, 
		DOMAIN_ALIAS_RID_ADMINS,
		0, 0, 0, 0, 0, 0, &psidAdmin)) {
		free(ptg);
        return FALSE;
	}
	
    fAdmin= FALSE;
	
    for (dwGroup= 0; dwGroup < ptg->GroupCount; dwGroup++) {
        if (EqualSid (ptg->Groups[dwGroup].Sid, psidAdmin)) {
            fAdmin = TRUE;
            break;
        }
    }
	
    FreeSid(psidAdmin);
	free(ptg);
	
    return (fAdmin);
}

