
#include "includes.h"

struct passwd *win32port_getpwuid(uid_t uid) {
	__declspec (thread) static struct passwd pwd;
	const char *path;
	DWORD len;

	if (uid != getuid()) {
		errno = ENOENT;
		return NULL; /* For now we only do own ID */
	}
	
	/* Initialize buffer */
	memset(&pwd, 0, sizeof(pwd));
	pwd.pw_name = pwd.pw_name_buf;
	pwd.pw_shell = pwd.pw_name_buf;
	pwd.pw_dir = pwd.pw_dir_buf;
	len = sizeof(pwd.pw_name_buf);

	GetUserName(pwd.pw_name_buf, &len);
	
	if (strlen(pwd.pw_name_buf) == 0)
		strcpy(pwd.pw_name_buf, "nobody");

#if WIN32PORT_PWD_H_ENABLE_UNIX_TRANSFORM_ON_NAME
	for(p = pwd.pw_name_buf; *p; p++) {
		if (isspace(*p))
			*p = '_';
		if (isupper(*p))
			*p = tolower(*p);
		if (!strchr("abcdefghijklmnopqrstuvwzyz1234567890_", *p))
			*p = 'X';
	}
#endif /* WIN32PORT_PWD_H_ENABLE_UNIX_TRANSFORM_ON_NAME */

	if (path = win32port_get_ssh_data_path(NULL))
		strcpy(pwd.pw_dir_buf, path);

	strcpy(pwd.pw_shell_buf, "COMMAND.COM");

	return &pwd;
}

struct passwd *win32port_getpwnam(const char *login) {
	char name[MAX_PW_NAME_LEN];
	DWORD len = sizeof(name);

	if (login && *login 
		&& GetUserName(name, &len)
		&& (strcmp(login, name) == 0))
		return win32port_getpwuid(getuid());

	errno = ENOENT;
	return NULL;
}
