
#include "includes.h"

int win32port_get_registry_value(HKEY root, 
								 const char *key, 
								 const char *value, 
								 char *return_buf, 
								 DWORD *return_buf_len) {
	size_t tmp_len;
	DWORD error_status;
	HKEY registry_handle;
	char *tmp_buffer;
	DWORD key_type = 0;
	if ((error_status = RegOpenKeyEx(
		root, key, 0, KEY_QUERY_VALUE, &registry_handle)) == ERROR_SUCCESS) {
		if ((error_status = RegQueryValueEx(registry_handle, value, NULL, 
			&key_type, return_buf, return_buf_len)) == ERROR_SUCCESS) {
			if (key_type == REG_EXPAND_SZ) {
				tmp_len = strlen(return_buf) + 256;
				tmp_buffer = alloca(tmp_len);
				error_status = ExpandEnvironmentStrings(return_buf, tmp_buffer, 
					tmp_len);
				strcpy(return_buf, tmp_buffer);
			}
		}
		RegCloseKey(registry_handle);
	}
	
	if (error_status == ERROR_SUCCESS)
		return 0;
	
	return -1;
}
