
#include "includes.h"

#include <conio.h>
#include <assert.h>

extern int win32port_fcntl_nonblocking;

#undef read
#undef write

ssize_t win32port_read(int d, char *buf, size_t nbytes) 
{	
	int err, bytes = recv(d, buf, nbytes, 0);
	
	if (bytes <= 0) {
		if ((err = WSAGetLastError()) == WSAENOTSOCK) {
			if ((d == fileno(stdin))/* && win32port_fcntl_nonblocking */ ) {
				/* non-blocking stdin on console */ 
				int ch;
				for(bytes = 0; _kbhit() && (bytes < nbytes); bytes++) {
					if ((ch = _getch()) == EOF)
						break;
					buf[bytes] = (char)ch;
				}
				return bytes ? bytes : -1;
			}

			return read(d, buf, nbytes);
		}
		if (err == WSAEWOULDBLOCK) {
			assert(0);
		}
	}
	return bytes;
}

ssize_t win32port_write(int d, const char *buf, size_t nbytes) 
{	
	int bytes = send(d, buf, nbytes, 0);
	
	if (bytes <= 0) {
		if (WSAGetLastError() == WSAENOTSOCK)
			return write(d, buf, nbytes);
		return 0;
	}
	return bytes;
}
