
#include "includes.h"
#include "ssh.h"

/* jgaa oct 9th 2000: 
 * Simple check to see if a file is unprotected.
 * We simply require that the file resides in the
 * users "home" directory.
 *
 * Returns 0 if everything is fine, -1 if things look bad.
 */


int win32port_unprotected_file(const char *filename) {
	const char* ssh_path = win32port_get_ssh_data_path(SSH_USER_DIR);

	if (NULL == ssh_path)
		return -1;

	if ((NULL == filename) || (0 == filename[0]))
		return -1;

	return strnicmp(ssh_path, filename, strlen(filename)) == 0;
}

